Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4423)
@@ -45,18 +45,30 @@
   /// The SlaveCommunicator manages the whole communication with the slave
   /// </summary>
-  public class SlaveCommunicator : ISlaveCommunicator,
-    IInternalSlaveCommunicator {
+  public class SlaveCommunicator : ISlaveCommunicator, IInternalSlaveCommunicator {
     private static Dictionary<Guid, DateTime> lastHeartbeats = new Dictionary<Guid, DateTime>();
+
+    /// <summary>
+    /// Contains a list job JobIds which have been sent to a slave, but the slave has not yet sent 
+    /// a jobProgress of the job with a heartbeat, because he has not finished downloading/deserializing it.
+    /// The number value indicates a TimeToLive count that is decremented with each server-heartbeat.
+    /// When the number reaches zero, the jobs is assumed to be lost and is set Offline again.
+    /// </summary>
     private static Dictionary<Guid, int> newAssignedJobs = new Dictionary<Guid, int>();
+
+    /// <summary>
+    /// When a slave reconnects and he has finished results waiting it calls IsJobStillNeeded. If the finished 
+    /// result has not yet been collected from anywhere else, the job will be sent by the slave and the job state is set to Pending.
+    /// Now the job be in pending state until it is received from the reconnected slave or the TimeToLive value of this dictionary has reached zero.
+    /// </summary>
     private static Dictionary<Guid, int> pendingJobs = new Dictionary<Guid, int>();
+    private static int PENDING_TIMEOUT = 100;
 
     private static ReaderWriterLockSlim heartbeatLock = new ReaderWriterLockSlim(LockRecursionPolicy.SupportsRecursion);
 
-    //private ISessionFactory factory;
     private ILifecycleManager lifecycleManager;
     private IInternalJobManager jobManager;
     private IScheduler scheduler;
 
-    private static int PENDING_TIMEOUT = 100;
+    private static object slaveLocker = new object();
 
     /// <summary>
@@ -66,11 +78,9 @@
     /// </summary>
     public SlaveCommunicator() {
-      //factory = ServiceLocator.GetSessionFactory();
-
       lifecycleManager = ServiceLocator.GetLifecycleManager();
       jobManager = ServiceLocator.GetJobManager() as IInternalJobManager;
       scheduler = ServiceLocator.GetScheduler();
 
-      lifecycleManager.RegisterHeartbeat(new EventHandler(lifecycleManager_OnServerHeartbeat));
+      lifecycleManager.ServerHeartbeat += new EventHandler(lifecycleManager_OnServerHeartbeat);
     }
 
@@ -82,31 +92,28 @@
     /// <param name="e"></param>
     void lifecycleManager_OnServerHeartbeat(object sender, EventArgs e) {
-      Logger.Debug("Server Heartbeat ticked");
-
-      // [chn] why is transaction management done here
-      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
-        List<SlaveDto> allSlaves = new List<SlaveDto>(DaoLocator.SlaveDao.FindAll());
-
-        foreach (SlaveDto slave in allSlaves) {
-          if (slave.State != SlaveState.Offline && slave.State != SlaveState.NullState) {
+      // this block can conflict with the heartbeats from a slave (which also updates the slave-records)
+      lock (slaveLocker) {
+        Logger.Debug("Server Heartbeat ticked");
+        List<Guid> slaveIds = DaoLocator.SlaveDao.FindAll().Select(s => s.Id).ToList();
+
+        foreach (Guid slaveId in slaveIds) {
+          using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
             heartbeatLock.EnterUpgradeableReadLock();
+            SlaveDto slave = DaoLocator.SlaveDao.FindById(slaveId);
 
             if (!lastHeartbeats.ContainsKey(slave.Id)) {
-              Logger.Info("Slave " + slave.Id +
-                              " wasn't offline but hasn't sent heartbeats - setting offline");
-              slave.State = SlaveState.Offline;
-              DaoLocator.SlaveDao.Update(slave);
-              Logger.Info("Slave " + slave.Id +
-                              " wasn't offline but hasn't sent heartbeats - Resetting all his jobs");
-              foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfSlave(slave)) {
-                //maybe implementa n additional Watchdog? Till then, just set them offline..
-                DaoLocator.JobDao.SetJobOffline(job);
-              }
+              Logger.Info("No previous hearbeats are available for " + slave.Id + " although it is in state " + slave.State);
+
+              // add a heartbeat NOW and give the slave time to say something for HEARTBEAT_MAX_DIF
+              // otherwise alls the slaves jobs would be aborted, which is not desirable if the server has just been restarted
+              heartbeatLock.EnterWriteLock();
+              lastHeartbeats.Add(slave.Id, DateTime.Now);
+              heartbeatLock.ExitWriteLock();
             } else {
-              DateTime lastHbOfSlave = lastHeartbeats[slave.Id];
-
-              TimeSpan dif = DateTime.Now.Subtract(lastHbOfSlave);
+              DateTime lastHeartbeatOfSlave = lastHeartbeats[slave.Id];
+
+              TimeSpan diff = DateTime.Now.Subtract(lastHeartbeatOfSlave);
               // check if time between last hearbeat and now is greather than HEARTBEAT_MAX_DIF
-              if (dif.TotalSeconds > ApplicationConstants.HEARTBEAT_MAX_DIF) {
+              if (diff.TotalSeconds > ApplicationConstants.HEARTBEAT_MAX_DIF) {
                 // if slave calculated jobs, the job must be reset
                 Logger.Info("Slave timed out and is on RESET");
@@ -119,8 +126,6 @@
                 }
                 Logger.Debug("setting slave offline");
-                // slave must be set offline
                 slave.State = SlaveState.Offline;
 
-                //slaveAdapter.Update(slave);
                 DaoLocator.SlaveDao.Update(slave);
 
@@ -131,29 +136,21 @@
               }
             }
-
             heartbeatLock.ExitUpgradeableReadLock();
-          } else {
-            //TODO: RLY neccesary?
-            //HiveLogger.Info(this.ToString() + ": Slave " + slave.Id + " has wrong state: Shouldn't have offline or nullstate, has " + slave.State);
-            heartbeatLock.EnterWriteLock();
-            //HiveLogger.Info(this.ToString() + ": Slave " + slave.Id + " has wrong state: Resetting all his jobs");
-            if (lastHeartbeats.ContainsKey(slave.Id))
-              lastHeartbeats.Remove(slave.Id);
-            foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfSlave(slave)) {
-              DaoLocator.JobDao.SetJobOffline(job);
-            }
-            heartbeatLock.ExitWriteLock();
-          }
-        }
-        CheckForPendingJobs();
-        //        DaoLocator.DestroyContext();
-        scope.Complete();
-      }
+            scope.Complete();
+          } // using
+        } // foreach
+
+        using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
+          CheckForPendingJobs();
+          scope.Complete();
+        }
+        Logger.Debug("Server Heartbeat ended");
+      } // lock
     }
 
     private void CheckForPendingJobs() {
-      IList<JobDto> pendingJobsInDB = new List<JobDto>(DaoLocator.JobDao.GetJobsByState(JobState.Pending));
-
-      foreach (JobDto currJob in pendingJobsInDB) {
+      IList<JobDto> pendingJobsInDb = new List<JobDto>(DaoLocator.JobDao.GetJobsByState(JobState.Pending));
+
+      foreach (JobDto currJob in pendingJobsInDb) {
         lock (pendingJobs) {
           if (pendingJobs.ContainsKey(currJob.Id)) {
@@ -192,8 +189,9 @@
       slave.CalendarSyncStatus = dbSlave != null ? dbSlave.CalendarSyncStatus : CalendarState.NotAllowedToFetch;
       slave.State = SlaveState.Idle;
-
-      if (dbSlave == null)
+      slave.Login = DateTime.Now;
+
+      if (dbSlave == null) {
         DaoLocator.SlaveDao.Insert(slave);
-      else {
+      } else {
         DaoLocator.SlaveDao.Update(slave);
       }
@@ -207,6 +205,5 @@
       SlaveDto slave = DaoLocator.SlaveDao.FindById(slaveId);
       if (slave == null) {
-        //response.Success = false;
-        response.StatusMessage = ResponseStatus.GetCalendar_ResourceNotFound;
+        response.StatusMessage = ResponseStatus.GetCalendar_ResourceDoesNotExist;
         return response;
       }
@@ -217,7 +214,5 @@
       if (appointments.Count() == 0) {
         response.StatusMessage = ResponseStatus.GetCalendar_NoCalendarFound;
-        //response.Success = false;
       } else {
-        //response.Success = true;
         response.Appointments = appointments;
       }
@@ -232,6 +227,5 @@
       SlaveDto slave = DaoLocator.SlaveDao.FindById(slaveId);
       if (slave == null) {
-        //response.Success = false;
-        response.StatusMessage = ResponseStatus.GetCalendar_ResourceNotFound;
+        response.StatusMessage = ResponseStatus.GetCalendar_ResourceDoesNotExist;
         return response;
       }
@@ -251,29 +245,52 @@
     /// <returns></returns>
     public ResponseHeartBeat ProcessHeartBeat(HeartBeatData heartbeatData) {
-      Logger.Debug("BEGIN Processing Heartbeat for Slave " + heartbeatData.SlaveId);
-
-      ResponseHeartBeat response = new ResponseHeartBeat();
-      response.ActionRequest = new List<MessageContainer>();
-
-      Logger.Debug("BEGIN Started Slave Fetching");
-      SlaveDto slave = DaoLocator.SlaveDao.FindById(heartbeatData.SlaveId);
-      Logger.Debug("END Finished Slave Fetching");
-
-      slave.NrOfFreeCores = heartbeatData.FreeCores;
-      slave.FreeMemory = heartbeatData.FreeMemory;
-      slave.IsAllowedToCalculate = heartbeatData.IsAllowedToCalculate;
-
-      // check if the slave is logged in
-      if (slave.State == SlaveState.Offline || slave.State == SlaveState.NullState) {
-        response.StatusMessage = ResponseStatus.ProcessHeartBeat_UserNotLoggedIn;
-        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.NoMessage));
-        Logger.Error("ProcessHeartBeat: Slave state null or offline: " + slave);
-        return response;
-      }
-
-      // save timestamp of this heartbeat
-      Logger.Debug("BEGIN Locking for Heartbeats");
+      lock (slaveLocker) {
+        Logger.Debug("BEGIN Processing Heartbeat for Slave " + heartbeatData.SlaveId);
+        ResponseHeartBeat response = new ResponseHeartBeat();
+        response.ActionRequest = new List<MessageContainer>();
+
+        using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
+          SlaveDto slave = UpdateSlaveData(heartbeatData);
+          SaveTimestamp(heartbeatData);
+
+          //ProcessJobProgress(heartbeatData, response);
+          response.ActionRequest = ProcessJobProgress(heartbeatData);
+
+          //check if new Cal must be loaded
+          if (slave.CalendarSyncStatus == CalendarState.Fetch || slave.CalendarSyncStatus == CalendarState.ForceFetch) {
+            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchOrForceFetchCalendar));
+            Logger.Info("fetch or forcefetch sent");
+          }
+
+          // check if slave has a free core for a new job
+          // if true, ask scheduler for a new job for this slave
+          Logger.Debug(" BEGIN Looking for Slave Jobs");
+          if (this.IsAllowedToSendJobs() &&
+              slave.IsAllowedToCalculate &&
+              heartbeatData.FreeCores > 0 &&
+              scheduler.ExistsJobForSlave(heartbeatData)) {
+            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchJob));
+          } else {
+            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.NoMessage));
+          }
+
+          DaoLocator.SlaveDao.Update(slave);
+          scope.Complete();
+        }
+        Logger.Debug(" END Processed Heartbeat for Slave " + heartbeatData.SlaveId);
+        return response;
+      }
+    }
+
+    /// <summary>
+    /// Returns true if there are enough resources to send a job
+    /// There should not be too many jobs sent simultaniously
+    /// </summary>
+    private bool IsAllowedToSendJobs() {
+      return lifecycleManager.JobsCurrentlyTransferring < ApplicationConstants.MAX_JOB_TRANSFER_COUNT;
+    }
+
+    private static void SaveTimestamp(HeartBeatData heartbeatData) {
       heartbeatLock.EnterWriteLock();
-      Logger.Debug("END Locked for Heartbeats");
       if (lastHeartbeats.ContainsKey(heartbeatData.SlaveId)) {
         lastHeartbeats[heartbeatData.SlaveId] = DateTime.Now;
@@ -282,31 +299,103 @@
       }
       heartbeatLock.ExitWriteLock();
-
-      Logger.Debug("BEGIN Processing Heartbeat Jobs");
-      ProcessJobProcess(heartbeatData, response);
-      Logger.Debug("END Processed Heartbeat Jobs");
-
-      //check if new Cal must be loaded
-      if (slave.CalendarSyncStatus == CalendarState.Fetch || slave.CalendarSyncStatus == CalendarState.ForceFetch) {
-        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchOrForceFetchCalendar));
-        //slave.CalendarSyncStatus = CalendarState.Fetching;
-        Logger.Info("fetch or forcefetch sent");
-      }
-
-      // check if slave has a free core for a new job
-      // if true, ask scheduler for a new job for this slave
-      Logger.Debug(" BEGIN Looking for Slave Jobs");
-      if (slave.IsAllowedToCalculate && heartbeatData.FreeCores > 0 && scheduler.ExistsJobForSlave(heartbeatData)) {
-        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchJob));
-      } else {
-        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.NoMessage));
-      }
-      Logger.Debug(" END Looked for Slave Jobs");
-
-      DaoLocator.SlaveDao.Update(slave);
-
-      //tx.Commit();
-      Logger.Debug(" END Processed Heartbeat for Slave " + heartbeatData.SlaveId);
-      return response;
+    }
+
+    private SlaveDto UpdateSlaveData(HeartBeatData heartbeatData) {
+      SlaveDto slave = DaoLocator.SlaveDao.FindById(heartbeatData.SlaveId);
+      if (slave == null) {
+        slave = new SlaveDto() { Id = heartbeatData.SlaveId };
+        Login(slave);
+        slave = DaoLocator.SlaveDao.FindById(heartbeatData.SlaveId);
+      }
+
+      slave.NrOfFreeCores = heartbeatData.FreeCores;
+      slave.FreeMemory = heartbeatData.FreeMemory;
+      slave.IsAllowedToCalculate = heartbeatData.IsAllowedToCalculate;
+
+      slave.State = heartbeatData.JobProgress.Count > 0 ? SlaveState.Calculating : SlaveState.Idle;
+      return slave;
+    }
+
+    private List<MessageContainer> ProcessJobProgress(HeartBeatData heartbeatData) {
+      List<MessageContainer> actions = new List<MessageContainer>();
+
+      // find all the jobs in jobProgress which are not in the database -> they are not supposed to be calculated by this slave
+      IEnumerable<Guid> jobsToAbort = GetJobsNotInDatabase(heartbeatData.SlaveId, heartbeatData.JobProgress.Keys);
+      foreach (Guid jobId in jobsToAbort) {
+        actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobId));
+        heartbeatData.JobProgress.Remove(jobId);
+      }
+
+      // process all the remaining jobProgresses
+      foreach (var jobProgress in heartbeatData.JobProgress) {
+        JobDto curJob = DaoLocator.JobDao.FindById(jobProgress.Key);
+        if (curJob == null) {
+          // job does not exist in db
+          actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobProgress.Key));
+          Logger.Error("Job does not exist in DB: " + jobProgress.Key);
+        } else {
+          curJob.Slave = DaoLocator.SlaveDao.GetSlaveForJob(curJob.Id);
+          if (curJob.Slave == null || curJob.Slave.Id != heartbeatData.SlaveId) {
+            // assigned slave does not match heartbeat
+            actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
+            Logger.Error("The slave " + heartbeatData.SlaveId + " is not supposed to calculate Job: " + curJob);
+          } else {
+            // save job execution time
+            curJob.ExecutionTime = jobProgress.Value;
+
+            if (curJob.State == JobState.Aborted) {
+              // a request to abort the job has been set
+              actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
+            } else if (curJob.State == JobState.SnapshotRequested) {
+              // a request for a snapshot has been set
+              actions.Add(new MessageContainer(MessageContainer.MessageType.RequestSnapshot, curJob.Id));
+              curJob.State = JobState.SnapshotSent;
+            }
+          }
+        }
+        DaoLocator.JobDao.Update(curJob);
+      }
+
+      var jobsOfSlave = DaoLocator.JobDao.FindActiveJobsOfSlave(DaoLocator.SlaveDao.FindById(heartbeatData.SlaveId));
+      foreach (JobDto currJob in jobsOfSlave) {
+        if (heartbeatData.JobProgress.ContainsKey(currJob.Id)) {
+          lock (newAssignedJobs) {
+            if (newAssignedJobs.ContainsKey(currJob.Id)) {
+              Logger.Info("Job is sending a heart beat, removing it from the newAssignedJobList: " + currJob);
+              newAssignedJobs.Remove(currJob.Id);
+            }
+          }
+        } else {
+          lock (newAssignedJobs) {
+            if (newAssignedJobs.ContainsKey(currJob.Id)) {
+              newAssignedJobs[currJob.Id]--;
+              Logger.Error("Job TTL Reduced by one for job: " + currJob + "and is now: " + newAssignedJobs[currJob.Id] + ". User that sucks: " + currJob.Slave);
+              if (newAssignedJobs[currJob.Id] <= 0) {
+                Logger.Error("Job TTL reached Zero, Job gets removed: " + currJob + " and set back to offline. User that sucks: " + currJob.Slave);
+
+                currJob.State = JobState.Offline;
+                DaoLocator.JobDao.Update(currJob);
+
+                actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, currJob.Id));
+
+                newAssignedJobs.Remove(currJob.Id);
+              }
+            } else {
+              Logger.Error("Job ID wasn't with the heartbeats:  " + currJob);
+              currJob.State = JobState.Offline;
+              DaoLocator.JobDao.Update(currJob);
+            }
+          } // lock
+        }
+      }
+      return actions;
+    }
+
+    /// <summary>
+    /// Returns the jobIds of the jobs which are not assigned to this slave in the database
+    /// </summary>
+    private IEnumerable<Guid> GetJobsNotInDatabase(Guid slaveId, IEnumerable<Guid> jobIds) {
+      IEnumerable<Guid> activeJobsOfSlave = DaoLocator.JobDao.FindActiveJobsOfSlave(DaoLocator.SlaveDao.FindById(slaveId)).Select(j => j.Id);
+      return jobIds.Except(activeJobsOfSlave).ToList();
     }
 
@@ -333,92 +422,91 @@
     /// (2) state Abort results in Finished. This should be: AbortRequested, Aborted.
     /// </summary>
-    /// <param name="hbData"></param>
-    /// <param name="jobAdapter"></param>
-    /// <param name="slaveAdapter"></param>
+    /// <param name="heartbeatData"></param>
     /// <param name="response"></param>
-    private void ProcessJobProcess(HeartBeatData hbData, ResponseHeartBeat response) {
-      Logger.Debug("Started for Slave " + hbData.SlaveId);
-      List<JobDto> jobsOfSlave = new List<JobDto>(DaoLocator.JobDao.FindActiveJobsOfSlave(DaoLocator.SlaveDao.FindById(hbData.SlaveId)));
-      if (hbData.JobProgress != null && hbData.JobProgress.Count > 0) {
-        if (jobsOfSlave == null || jobsOfSlave.Count == 0) {
-          foreach (Guid jobId in hbData.JobProgress.Keys) {
-            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobId));
-          }
-
-          Logger.Error("There is no job calculated by this user " + hbData.SlaveId + ", advise him to abort all");
-          return;
-        }
-
-        foreach (KeyValuePair<Guid, double> jobProgress in hbData.JobProgress) {
-          JobDto curJob = DaoLocator.JobDao.FindById(jobProgress.Key);
-          if (curJob == null) {
-            response.StatusMessage = ResponseStatus.ProcessJobResult_JobDoesNotExist;
-            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobProgress.Key));
-            Logger.Error("Job does not exist in DB: " + jobProgress.Key);
-            return;
-          }
-          curJob.Slave = DaoLocator.SlaveDao.GetSlaveForJob(curJob.Id);
-          if (curJob.Slave == null || curJob.Slave.Id != hbData.SlaveId) {
-            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
-            Logger.Error("There is no job calculated by this user " + hbData.SlaveId + " Job: " + curJob);
-          } else if (curJob.State == JobState.Aborted) {
-            // a request to abort the job has been set
-            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
-            curJob.State = JobState.Finished;
-          } else {
-            // save job progress
-            curJob.Percentage = jobProgress.Value;
-
-            if (curJob.State == JobState.SnapshotRequested) {
-              // a request for a snapshot has been set
-              response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.RequestSnapshot, curJob.Id));
-              curJob.State = JobState.SnapshotSent;
-            }
-          }
-          DaoLocator.JobDao.Update(curJob);
-        }
-      }
-      foreach (JobDto currJob in jobsOfSlave) {
-        bool found = false;
-        if (hbData.JobProgress != null) {
-          foreach (Guid jobId in hbData.JobProgress.Keys) {
-            if (jobId == currJob.Id) {
-              found = true;
-              break;
-            }
-          }
-        }
-        if (!found) {
-          lock (newAssignedJobs) {
-            if (newAssignedJobs.ContainsKey(currJob.Id)) {
-              newAssignedJobs[currJob.Id]--;
-              Logger.Error("Job TTL Reduced by one for job: " + currJob + "and is now: " + newAssignedJobs[currJob.Id] + ". User that sucks: " + currJob.Slave);
-              if (newAssignedJobs[currJob.Id] <= 0) {
-                Logger.Error("Job TTL reached Zero, Job gets removed: " + currJob + " and set back to offline. User that sucks: " + currJob.Slave);
-
-                currJob.State = JobState.Offline;
-                DaoLocator.JobDao.Update(currJob);
-
-                response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, currJob.Id));
-
-                newAssignedJobs.Remove(currJob.Id);
-              }
-            } else {
-              Logger.Error("Job ID wasn't with the heartbeats:  " + currJob);
-              currJob.State = JobState.Offline;
-              DaoLocator.JobDao.Update(currJob);
-            }
-          } // lock
-        } else {
-          lock (newAssignedJobs) {
-
-            if (newAssignedJobs.ContainsKey(currJob.Id)) {
-              Logger.Info("Job is sending a heart beat, removing it from the newAssignedJobList: " + currJob);
-              newAssignedJobs.Remove(currJob.Id);
-            }
-          }
-        }
-      }
-    }
+    //private void ProcessJobProgress(HeartBeatData heartbeatData, ResponseHeartBeat response) {
+    //  Logger.Debug("Started for Slave " + heartbeatData.SlaveId);
+    //  List<JobDto> jobsOfSlave = new List<JobDto>(DaoLocator.JobDao.FindActiveJobsOfSlave(DaoLocator.SlaveDao.FindById(heartbeatData.SlaveId)));
+    //  if (heartbeatData.JobProgress != null && heartbeatData.JobProgress.Count > 0) {
+    //    if (jobsOfSlave == null || jobsOfSlave.Count == 0) {
+    //      foreach (Guid jobId in heartbeatData.JobProgress.Keys) {
+    //        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobId));
+    //      }
+
+    //      Logger.Error("There is no job calculated by this user " + heartbeatData.SlaveId + ", advise him to abort all");
+    //      return;
+    //    }
+
+    //    foreach (KeyValuePair<Guid, TimeSpan> jobProgress in heartbeatData.JobProgress) {
+    //      JobDto curJob = DaoLocator.JobDao.FindById(jobProgress.Key);
+    //      if (curJob == null) {
+    //        response.StatusMessage = ResponseStatus.ProcessJobResult_JobDoesNotExist;
+    //        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobProgress.Key));
+    //        Logger.Error("Job does not exist in DB: " + jobProgress.Key);
+    //        return;
+    //      }
+    //      curJob.Slave = DaoLocator.SlaveDao.GetSlaveForJob(curJob.Id);
+    //      if (curJob.Slave == null || curJob.Slave.Id != heartbeatData.SlaveId) {
+    //        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
+    //        Logger.Error("There is no job calculated by this user " + heartbeatData.SlaveId + " Job: " + curJob);
+    //      } else if (curJob.State == JobState.Aborted) {
+    //        // a request to abort the job has been set
+    //        response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
+    //        curJob.State = JobState.Finished;
+    //      } else {
+    //        // save job progress
+    //        curJob.ExecutionTime = jobProgress.Value;
+
+    //        if (curJob.State == JobState.SnapshotRequested) {
+    //          // a request for a snapshot has been set
+    //          response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.RequestSnapshot, curJob.Id));
+    //          curJob.State = JobState.SnapshotSent;
+    //        }
+    //      }
+    //      DaoLocator.JobDao.Update(curJob);
+    //    }
+    //  }
+
+    //  foreach (JobDto currJob in jobsOfSlave) {
+    //    bool found = false;
+    //    if (heartbeatData.JobProgress != null) {
+    //      foreach (Guid jobId in heartbeatData.JobProgress.Keys) {
+    //        if (jobId == currJob.Id) {
+    //          found = true;
+    //          break;
+    //        }
+    //      }
+    //    }
+
+    //    if (!found) {
+    //      lock (newAssignedJobs) {
+    //        if (newAssignedJobs.ContainsKey(currJob.Id)) {
+    //          newAssignedJobs[currJob.Id]--;
+    //          Logger.Error("Job TTL Reduced by one for job: " + currJob + "and is now: " + newAssignedJobs[currJob.Id] + ". User that sucks: " + currJob.Slave);
+    //          if (newAssignedJobs[currJob.Id] <= 0) {
+    //            Logger.Error("Job TTL reached Zero, Job gets removed: " + currJob + " and set back to offline. User that sucks: " + currJob.Slave);
+
+    //            currJob.State = JobState.Offline;
+    //            DaoLocator.JobDao.Update(currJob);
+
+    //            response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, currJob.Id));
+
+    //            newAssignedJobs.Remove(currJob.Id);
+    //          }
+    //        } else {
+    //          Logger.Error("Job ID wasn't with the heartbeats:  " + currJob);
+    //          currJob.State = JobState.Offline;
+    //          DaoLocator.JobDao.Update(currJob);
+    //        }
+    //      } // lock
+    //    } else {
+    //      lock (newAssignedJobs) {
+    //        if (newAssignedJobs.ContainsKey(currJob.Id)) {
+    //          Logger.Info("Job is sending a heart beat, removing it from the newAssignedJobList: " + currJob);
+    //          newAssignedJobs.Remove(currJob.Id);
+    //        }
+    //      }
+    //    }
+    //  }
+    //}
 
     /// <summary>
@@ -466,5 +554,5 @@
       //tx = session.BeginTransaction();
 
-      ResponseResultReceived response = ProcessJobResult(result.SlaveId, result.Id, new byte[] { }, result.Percentage, result.Exception, finished);
+      ResponseResultReceived response = ProcessJobResult(result.SlaveId, result.Id, new byte[] { }, result.ExecutionTime, result.Exception, finished);
 
       if (response.StatusMessage == ResponseStatus.Ok) {
@@ -495,5 +583,5 @@
     }
 
-    private ResponseResultReceived ProcessJobResult(Guid slaveId, Guid jobId, byte[] result, double? percentage, string exception, bool finished) {
+    private ResponseResultReceived ProcessJobResult(Guid slaveId, Guid jobId, byte[] result, TimeSpan executionTime, string exception, bool finished) {
       Logger.Info("BEGIN Job received for Storage - SUB method: " + jobId);
 
@@ -511,5 +599,4 @@
 
       if (job != null && job.JobInfo == null) {
-        //response.Success = false;
         response.StatusMessage = ResponseStatus.ProcessJobResult_JobDoesNotExist;
         response.JobId = jobId;
@@ -520,5 +607,4 @@
       }
       if (job.JobInfo.State == JobState.Aborted) {
-        //response.Success = false;
         response.StatusMessage = ResponseStatus.ProcessJobResult_JobAborted;
 
@@ -529,5 +615,4 @@
       }
       if (job.JobInfo.Slave == null) {
-        //response.Success = false;
         response.StatusMessage = ResponseStatus.ProcessJobResult_JobIsNotBeeingCalculated;
         response.JobId = jobId;
@@ -562,5 +647,4 @@
       }
       if (job.JobInfo.State != JobState.Calculating && job.JobInfo.State != JobState.Pending) {
-        //response.Success = false;
         response.StatusMessage = ResponseStatus.ProcessJobResult_InvalidJobState;
         response.JobId = jobId;
@@ -571,5 +655,5 @@
         return response;
       }
-      job.JobInfo.Percentage = percentage;
+      job.JobInfo.ExecutionTime = executionTime;
 
       if (!string.IsNullOrEmpty(exception)) {
@@ -600,21 +684,10 @@
     /// these job results will be stored in the database
     /// </summary>
-    /// <param name="slaveId"></param>
-    /// <param name="jobId"></param>
-    /// <param name="result"></param>
-    /// <param name="exception"></param>
-    /// <param name="finished"></param>
-    /// <returns></returns>
-    public ResponseResultReceived StoreFinishedJobResult(Guid slaveId,
-      Guid jobId,
-      byte[] result,
-      double percentage,
-      string exception) {
-
-      return ProcessJobResult(slaveId, jobId, result, percentage, exception, true);
-    }
-
-    public ResponseResultReceived ProcessSnapshot(Guid slaveId, Guid jobId, byte[] result, double percentage, string exception) {
-      return ProcessJobResult(slaveId, jobId, result, percentage, exception, false);
+    public ResponseResultReceived StoreFinishedJobResult(Guid slaveId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
+      return ProcessJobResult(slaveId, jobId, result, executionTime, exception, true);
+    }
+
+    public ResponseResultReceived ProcessSnapshot(Guid slaveId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
+      return ProcessJobResult(slaveId, jobId, result, executionTime, exception, false);
     }
 
@@ -637,5 +710,4 @@
       SlaveDto slave = DaoLocator.SlaveDao.FindById(slaveId);
       if (slave == null) {
-        //response.Success = false;
         response.StatusMessage = ResponseStatus.Logout_SlaveNotRegistered;
         return response;
